function NewLabel = SmoothBoundary(Label,numP)


[L, num] = bwlabel(Label, 8);
NewLabel = zeros(size(Label,1),size(Label,2));

if(num>2)
    % remove the small segments.
    ConnCompInfo = bwconncomp(Label);
    numPixels = cellfun(@numel,ConnCompInfo.PixelIdxList);
    [biggest,idx] = max(numPixels);
    Label(ConnCompInfo.PixelIdxList{idx}) = 0;
    NewLabel(ConnCompInfo.PixelIdxList{idx}) = 1;
    
    ConnCompInfo = bwconncomp(Label);
    numPixels = cellfun(@numel,ConnCompInfo.PixelIdxList);
    [biggest,idx] = max(numPixels);
    NewLabel(ConnCompInfo.PixelIdxList{idx}) = 1;
    [L, num] = bwlabel(NewLabel, 8);
end

for i = 1:num
    bw = (L == i);
    spcurve = fitSpline(bw,numP);
    bw = roipoly(bw,spcurve(:,2),spcurve(:,1));
    NewLabel = NewLabel + bw;
end

