
ImPath = '.\Patient_Xrays\';
ModelPath = '.\Model_Xrays\';


%% read all the X-rays in Patient_X_rays folder
ext = {'*.tif','*.dcm', '*.png', '*.bmp','*.jpg'};
imlist = [];
for i = 1:length(ext)
    list = dir([ImPath ext{i}]);
    imlist = [imlist; list];
end

if(isempty(imlist))
    error('Please locate your X-rays into Patient_Xrays folder. The X-rays can be in tif, dcm, png, bmp, or jpg.\n')
end
fprintf('%d X-rays will be segmented... \n\n',length(imlist))

for i = 1:length(imlist)
    
    fprintf('Processing file %s   (%d)... \n',imlist(i).name,i)
    fname = sprintf('%s%s',ImPath,imlist(i).name);
    
    Mask = LungSegment(fname,ModelPath);
     
    %% save the mask
    [~,fname,~] = fileparts(imlist(i).name);
    fname = sprintf('%s.png',fname);
    imwrite(Mask, fname, 'png');
end

fprintf('End of the segmentation process. \n')